//
// OMNeT++ Arrival Process Module Example Package
//
// Author: Jan Kriege (Department of Computer Science, TU Dortmund, jan.kriege@tu-dortmund.de)
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef __SERVER_H__
#define __SERVER_H__

#include "omnetpp.h"
#include <map>

using namespace omnetpp;

// A simple Server
class Server : public cSimpleModule {
	private:
		cMessage *endOfServiceMessage;
		cMessage *currentJob;
		// Queue for jobs to process
		cQueue queue;
		// length of queue
		int buffer;
		// stores the amount of time the queue is filled with x jobs
		std::map<unsigned int, simtime_t> queueLength;
		// last time a job was added to or removed from queue
		simtime_t lastTime;
	protected:
		virtual void initialize();
		virtual void handleMessage(cMessage *msg);
		virtual void finish();
	public:
		Server();
		virtual ~Server();
};

#endif
