//
// OMNeT++ Arrival Process Module Example Package
//
// Author: Jan Kriege (Department of Computer Science, TU Dortmund, jan.kriege@tu-dortmund.de)
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#include "Sink.h"

Define_Module(Sink);

void Sink::initialize() {
    qstats.setName("stats");
}

void Sink::handleMessage(cMessage *msg) {
	simtime_t d = simTime()-msg->getCreationTime();
	EV << "Job is leaving system: " << msg->getName() << ", total time: " << d << endl;
	qstats.collect(d);
	delete msg;
}

void Sink::finish() {
    EV << "Total jobs processed: " << qstats.getCount() << endl;
    EV << "Average time: " << qstats.getMean() << endl;
    EV << "Max time: " << qstats.getMax() << endl;
}
